<template>
    <v-container fluid grid-list-md class="pt-0">
        <v-layout row wrap>
            <v-flex d-flex xs12>
                <v-layout row wrap>
                    <v-flex d-flex xs12 sm8>
                        <v-layout row wrap>
                            <v-flex xs12>
                                <ApplicationCard :item="application" :editable="false"
                                    :hideActions="['all']" :draggable="false">
                                    <template slot="header">
                                        <div class="subheading">
                                            <div v-if="!edit.title">
                                                <span 
                                                    @click="startEdit('title')"
                                                    class="editable">{{root.title}}
                                                </span>
                                                <a v-if="root.listingUrl"
                                                    target="_blank"
                                                    class="unstyled-link"
                                                    :href="root.listingUrl">
                                                    <v-icon
                                                        color="primary"
                                                        class="body-2"
                                                        style="vertical-align: super;">launch
                                                    </v-icon>
                                                </a>
                                            </div>
                                            <v-text-field 
                                                @blur="endEdit('title')" 
                                                @keydown.esc.stop="cancelEdit('title')" 
                                                @keydown.ctrl.enter="endEdit('title')"
                                                autofocus v-if="edit.title"
                                                browser-autocomplete='off'
                                                v-model="root.title"></v-text-field>
                                        </div>
                                        <div class="caption" style="color: #777">
                                            {{root.location}}
                                        </div>
                                    </template>

                                    <template slot="innerBody">
                                        <v-flex xs12 v-if="!!application"
                                            class="mt-2">
                                            <div v-if="!edit.description" 
                                                @click="startEdit('description')"
                                                class="editable">
                                                <div v-if="root.description"
                                                    v-html="root.description"
                                                    style="white-space: pre-line;" />
                                                <span v-else style="font-style: italic; color: #999">
                                                    {{$i18n.t("application.noDescription")}}
                                                </span>
                                            </div>
                                            <div v-if="edit.description">
                                                <v-textarea 
                                                    @blur="endEdit('description')" 
                                                    @keydown.ctrl.enter="endEdit('description')" 
                                                    @keydown.esc.stop="cancelEdit('description')"
                                                    autofocus
                                                    browser-autocomplete='off'
                                                    rows="1" auto-grow
                                                    v-model="root.description"></v-textarea>
                                            </div>
                                        </v-flex>
                                    </template>

                                    <template slot="leftActions">
                                        <span class="pl-2">
                                        <v-icon small v-if="root.status=='SAVED'">work_outline</v-icon>
                                        <v-icon small v-if="root.status=='APPLIED'">check</v-icon>
                                        <v-icon small v-if="root.status=='IN_PROGRESS'">cached</v-icon>
                                        <v-icon small v-if="root.status=='CLOSED'">inbox</v-icon>
                                        </span>
                                        <v-menu transition="slide-y-transition" top>
                                          <template slot="activator">
                                            <span class="pl-2">
                                              {{$i18n.t("application.status." + status.toLowerCase()).toUpperCase()}}
                                            </span>
                                          </template>
                                          <v-list>
                                            <v-list-tile v-for="(item, i) in allStatus" :key="i" @click="setStatus(item.status)" >
                                              <v-list-tile-title>{{ item.title }}</v-list-tile-title>
                                            </v-list-tile>
                                          </v-list>
                                        </v-menu>
                                    </template>

                                </ApplicationCard>
                            </v-flex>

                            <v-flex xs12 class="hidden-xs-only">
                                <ObjectInspector v-if="!!companyReady"
                                    :title="$i18n.t('application.view.company.companyInfo')" v-model="company"
                                    :show-all="false" :editable="false"
                                    :keyMap="companyKeyMap" />
                                 <v-card v-else >
                                    <v-card-title>
                                        <v-flex xs12>
                                            <span class="subheading">{{$i18n.t("application.view.company.companyInfo")}}</span>
                                        </v-flex>
                                    </v-card-title>
                                    <v-card-text>
                                        <div class="mb-3 text-xs-center subheading" style="color: #999">
                                            {{$i18n.t("application.view.company.noAvailableInfo")}}
                                        </div>
                                    </v-card-text>                        
                                </v-card>
                            </v-flex>
                        </v-layout>
                    </v-flex>
                    
                    <v-flex d-flex xs12 sm4>
                        <ObjectInspector :title="$i18n.t('application.form.contactInformationShort')"
                            autofocus="firstName" v-model="contact" :log="true"
                            @input="endEdit('contact')" :show-all="true"
                            :editable="true" :keyMap="contactKeyMap"
                            :switches="['isRecruiter']" />
                    </v-flex>

                    <v-flex xs12 class="hidden-sm-and-up">
                        <ObjectInspector v-if="companyReady"
                            :title="$i18n.t('application.view.company.companyInfo')" v-model="company"
                            :show-all="false" :editable="false" :keyMap="companyKeyMap"/>
                    </v-flex>
                </v-layout>
            </v-flex>
        </v-layout>
    </v-container>
</template>


<script>
import ObjectInspector from '../../ObjectInspector'
import ApplicationCard from '../board/ApplicationCard'
export default {
  name: 'ApplicationView',
  props: ['application'],
  components: {
    ObjectInspector,
    ApplicationCard
  },
  data() {
    return {
        root: Object.assign({ contact: { } }, this.application),
        company: null,
        on: null,
        companyReady: false,
        edit: {
            prevent: false,
            description: false,
            title: false,
            contact: false,
            values: { }
        }
    }  
  },
  computed: {
    allStatus() {
      const values = ['SAVED', 'APPLIED', 'IN_PROGRESS', 'CLOSED'];
      return values.map((v) => {
         return {
           status: v,
           title: this.$i18n.t("application.status." + v.toLowerCase()).toUpperCase()
         }
      })
    },
    contactKeyMap() { 
        return  {
            firstName: this.$i18n.t("application.form.contact.firstName"),
            lastName: this.$i18n.t("application.form.contact.lastName"),
            phone: this.$i18n.t("application.form.contact.phone"),
            email: this.$i18n.t("application.form.contact.email"),
            isRecruiter: this.$i18n.t("application.form.contact.isRecruiter")
        }
    },
    companyKeyMap() {
        return {
            description: this.$i18n.t("application.view.company.description"), 
            foundedYear: this.$i18n.t("application.view.company.foundedYear"), 
            legalName: this.$i18n.t("application.view.company.legalName"),
            industry: this.$i18n.t("application.view.company.industry")
        }
    },
    status() {
        return this.root.status == 'CLOSED' ? 'ARCHIVED' : this.root.status;
    },
    contact: {
        get() {
          return !this.root.contact ? { firstName: ""} : this.root.contact
        },
        set(v) {
          this.root.contact = v
        }
    },
    descriptionWithLineBreaks() {
        return this.root.description ? this.root.description.replace(/\n/,"g", "<br/>") : null;
    }
  },
  mounted() {
    this.loadCompany();
  },
  methods: {
    startEdit(prop) {
        this.edit[prop] = true
        const value = this.root[prop]
        this.edit.values[prop] = typeof value == Object ? Object.assign({}, value) : value
    },
    cancelEdit(prop) {
        this.root[prop] = this.edit.values[prop]
        delete this.edit.values[prop]
        this.edit[prop] = false
    },
    async setStatus(status) {
        await this.$api.patchApplication(this.root.id, {status})
        this.root.status = status
    },
    async endEdit(prop) {
        try {
            const stop = this.edit.stop 
            this.edit.stop = true
            if ( stop ) return
            this.edit[prop] = false
            let params = {}
            params[prop] = this.root[prop]
            await this.$api.patchApplication(this.root.id, params, prop == 'description' || prop == 'title' ? { forceNull: prop } : {})
            delete this.edit.stop 
        }
        catch ( e ) {
          this.$logger.error(e.message);
          this.$emit("error", {
            message: `Could not save ${prop}`,
            color: "error"
          });
        }
    },
    loadCompany() {
        this.$api.getCompany(this.root.id).then((c) => { 
            c.industry = c.category ? c.category.industry : null
            c.linkedinHandle = c.linkedin ? c.linkedin.handle : "" 
            this.company = Object.assign({}, c)
            this.companyReady = !!this.company.name
        })
    }
  }
}
</script>


